#include "../../include/error.h"
#include "../../include/util.h"
#include "../../include/pool.h"

#include <stdlib.h>

void lm_pool_serve(lm_pool_t *pool, lm_mptp_t *packet, int sock, struct sockaddr *addr) {
  switch (MPTP_FLAGS_CODE(packet)) {
  case MPTP_C2S_PING:
    lm_mptp_init(packet, false, MPTP_S2C_PONG, true);
    goto end;

  case MPTP_C2S_INFO:
    if (NULL == pool->info.file) {
      lm_mptp_init(packet, false, MPTP_S2C_BRUH, true);
      goto end;
    }

    FILE  *info = fopen(pool->info.file, "r");
    size_t read = 0;

    while ((read = fread(packet->data, 1, MPTP_DATA_MAX, info)) > 0) {
      lm_mptp_server_send(sock, packet, addr);
      lm_mptp_init(packet, false, MPTP_S2C_COOL, false);
    }

    fclose(info);
    lm_mptp_init(packet, false, MPTP_S2C_COOL, true);
  }

end:
  lm_mptp_server_send(sock, packet, addr);
}

void lm_pool_serve_thread(void *_arg) {
  lm_pool_thread_arg_t *arg = _arg;
  lm_pool_serve(arg->pool, &arg->packet, arg->sock, &arg->addr);
  free(arg);
}
